package com.company.select.entity;

import io.jmix.core.metamodel.datatype.EnumClass;

import org.springframework.lang.Nullable;


public enum MusicStyleCategory implements EnumClass<Integer> {

    ALL(0),
    JAZZ(10),
    ROCK(20),
    METAL(30);

    private final Integer id;

    MusicStyleCategory(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    @Nullable
    public static MusicStyleCategory fromId(Integer id) {
        for (MusicStyleCategory at : MusicStyleCategory.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }
}