package com.company.select.view.musicchoice;

import com.company.select.entity.MusicChoice;

import com.company.select.entity.MusicStyle;
import com.company.select.entity.MusicStyleCategory;
import com.company.select.entity.Rating;
import com.company.select.view.main.MainView;

import com.vaadin.flow.component.AbstractField;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.component.select.JmixSelect;
import io.jmix.flowui.model.InstanceContainer;
import io.jmix.flowui.view.*;

import java.util.Objects;

import static com.company.select.entity.MusicStyle.getMusicStyleList;

@Route(value = "musicChoices/:id", layout = MainView.class)
@ViewController("MusicChoice.detail")
@ViewDescriptor("music-choice-detail-view.xml")
@EditedEntityContainer("musicChoiceDc")
public class MusicChoiceDetailView extends StandardDetailView<MusicChoice> {
    @ViewComponent
    private InstanceContainer<MusicChoice> musicChoiceDc;
    @ViewComponent
    private JmixSelect<MusicStyle> styleField;
    @ViewComponent
    private JmixSelect<Rating> ratingField;

    @Subscribe
    public void onBeforeShow(final BeforeShowEvent event) {
        styleField.setItems(getMusicStyleList(musicChoiceDc.getItem().getCategory()));
    }

    @Subscribe("categoryField")
    public void onCategoryFieldComponentValueChange(final AbstractField.ComponentValueChangeEvent<JmixSelect<MusicStyleCategory>, MusicStyleCategory> event) {
        styleField.setItems(getMusicStyleList(Objects.requireNonNull(event.getValue())));
        styleField.setValue(null);
        ratingField.setValue(null);
    }
}